#include <stdio.h>
#include <string.h>

#include "midiwrite.h"

#define withlen(str) strlen(str),str

int
main (void)
{
  midi_ctx m;

  m = midi_init (2);
  midi_set_subdiv (m, 120);
  midi_start (m, 500000, 4,2,120,8, 0,0);
  midi_meta_trackname (m, 1, withlen("Piano part"));
  midi_prg (m, 1, 0, 0);
  midi_ctl (m, 1, 0, 7, 100);
  midi_ctl (m, 1, 0, 10, 64);
  midi_meta_trackname (m, 2, withlen("Violin part"));
  midi_prg (m, 2, 1, 40);
  midi_ctl (m, 2, 1, 7, 65);
  midi_ctl (m, 2, 1, 10, 64);
  {
    int i;
    for ( i=0 ; i<=12 ; i++ )
      {
	midi_n_on (m, 1, 0, 60+i, 100);
	midi_wait (m, 1, 120);
	midi_n_on (m, 1, 0, 60+i, 0);
      }
    midi_sync (m);
    for ( i=0 ; i<=12 ; i++ )
      {
	midi_n_on (m, 2, 1, 60+i, 100);
	midi_wait (m, 2, 120);
	midi_n_on (m, 2, 1, 60+i, 0);
      }
    midi_n_on (m, 1, 0, 60, 100);
    midi_wait (m, 1, 480);
    midi_n_on (m, 1, 0, 60, 0);
    midi_n_on (m, 1, 0, 64, 100);
    midi_wait (m, 1, 360);
    midi_n_on (m, 1, 0, 64, 0);
    midi_n_on (m, 1, 0, 67, 100);
    midi_wait (m, 1, 600);
    midi_n_on (m, 1, 0, 67, 0);
    midi_n_on (m, 1, 0, 72, 100);
    midi_wait (m, 1, 120);
    midi_n_on (m, 1, 0, 72, 0);
    midi_sync (m);
  }
  midi_finish (m);
  midi_dump (m, stdout);
  midi_terminate (m);
  return 0;
}
